richardphibel / rpms / systemd

Forked from rpms/systemd a year ago
Clone
594167
From e5ecc772a0bb0813cdcf0a24f48ba3278da6e276 Mon Sep 17 00:00:00 2001
594167
From: Frantisek Sumsal <frantisek@sumsal.cz>
594167
Date: Wed, 15 Jun 2022 19:43:11 +0200
594167
Subject: [PATCH] test: don't wrap binaries built with ASan
594167
594167
since they should handle loading other instrumented libraries without
594167
issues.
594167
594167
(cherry picked from commit b727d7e02d6c88476ae9e46211e1f9c24720d5c3)
594167
594167
Related: #2087652
594167
---
594167
 test/test-functions | 10 +++++++---
594167
 1 file changed, 7 insertions(+), 3 deletions(-)
594167
594167
diff --git a/test/test-functions b/test/test-functions
594167
index f55e64493d..57d4df3e7e 100644
594167
--- a/test/test-functions
594167
+++ b/test/test-functions
594167
@@ -228,6 +228,8 @@ DEBUGTOOLS=(
594167
 )
594167
 
594167
 is_built_with_asan() {
594167
+    local _bin="${1:?}"
594167
+
594167
     if ! type -P objdump >/dev/null; then
594167
         ddebug "Failed to find objdump. Assuming systemd hasn't been built with ASAN."
594167
         return 1
594167
@@ -235,7 +237,7 @@ is_built_with_asan() {
594167
 
594167
     # Borrowed from https://github.com/google/oss-fuzz/blob/cd9acd02f9d3f6e80011cc1e9549be526ce5f270/infra/base-images/base-runner/bad_build_check#L182
594167
     local _asan_calls
594167
-    _asan_calls="$(objdump -dC "$SYSTEMD_JOURNALD" | grep -E "(callq?|brasl?|bl)\s.+__asan" -c)"
594167
+    _asan_calls="$(objdump -dC "$_bin" | grep -E "(callq?|brasl?|bl)\s.+__asan" -c)"
594167
     if ((_asan_calls < 1000)); then
594167
         return 1
594167
     else
594167
@@ -251,7 +253,7 @@ is_built_with_coverage() {
594167
     meson configure "${BUILD_DIR:?}" | grep 'b_coverage' | awk '{ print $2 }' | grep -q 'true'
594167
 }
594167
 
594167
-IS_BUILT_WITH_ASAN=$(is_built_with_asan && echo yes || echo no)
594167
+IS_BUILT_WITH_ASAN=$(is_built_with_asan "$SYSTEMD_JOURNALD" && echo yes || echo no)
594167
 IS_BUILT_WITH_COVERAGE=$(is_built_with_coverage && echo yes || echo no)
594167
 
594167
 if get_bool "$IS_BUILT_WITH_ASAN"; then
594167
@@ -2415,7 +2417,9 @@ inst_binary() {
594167
         wrap_binary=1
594167
     fi
594167
 
594167
-    if get_bool "$wrap_binary"; then
594167
+    # If the target binary is built with ASan support, we don't need to wrap
594167
+    # it, as it should handle everything by itself
594167
+    if get_bool "$wrap_binary" && ! is_built_with_asan "$bin"; then
594167
         dinfo "Creating ASan-compatible wrapper for binary '$target'"
594167
         # Install the target binary with a ".orig" suffix
594167
         inst_simple "$bin" "${target}.orig"